#include <bits/stdc++.h>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    string t;
    cin>>t;
    vector<bool> vis(t.length(), false);
    int res = t.length();
    int bg=0, en=t.length()-1;
    while(t[bg] == t[en] && bg<en)
    {
        res -= 2;
        bg++;
        en--;
    }
    if(en-bg<3)
    {
        cout<<0<<endl;
        return 0;
    }

    while(true)
    {
        int fnd = 0;
        for(int i=bg+1;i<=en;i++)
        {
            if(t[bg] == t[i] && !vis[i])
                fnd = i;
        }
        if(fnd)
        {
            bg++;
            vis[fnd] = true;
            res--;
        }
        else
            break;
    }

    while(true)
    {
        int fnd = 0;
        for(int i=en-1;i>=bg;i--)
        {
            if(t[en] == t[i] && !vis[i])
                fnd = i;
        }
        if(fnd)
        {
            en--;
            vis[fnd] = true;
            res--;
        }
        else
            break;
    }

    cout<<(res==1?0:res)<<endl;
    return 0;
}